<template>
    <div class="popup">
        <div class="popup-inner">
            <div v-if="this.loaded">
                <div v-for="data in this.gameData">
                <li> {{ data.gameworldid }} {{ data.name }}</li>
                <button @click="deleteThisGameworld(data.gameworldid)"> Delete </button>
                </div>
            </div>
            <button @click="closePopup()"> Close </button>
            <button @click="getGameworlds">reload</button>
        </div>
    </div>
</template>

<script lang ="ts">
    import {ref} from 'vue';
    import axios from 'axios';
    import store from '@/store/index';
    import { number } from 'zod';
    
    const gameData = ref(null);
    export default {
        name: 'deleteForm',
        props: ['closePopup'],
        data(){
            return{
                gameData,
                gameworldResponse: [],
                loaded: false,
            }
        },
        methods: {
            async getGameworlds(){
                try {
                    const response = await axios.get('http://localhost:8081/gameworlds');
                    this.gameData = response.data.gameworlds;
                    if(this.gameData==null || this.gameData==undefined)
                        this.loaded=false
                    else
                        this.loaded=true;
                }catch (error){
                    this.gameData = ["not available"];
                }
            },
            async deleteThisGameworld(id: number){
                await this.$store.dispatch('deleteThisGameworld', id);
                this.getGameworlds();
            }
        },
        computed:{
            gameDataFromStore() {
                return this.$store.state.gameData;
            }
        },
        mounted(){
            this.getGameworlds();
        }    
    }
</script>

<style>
    .popup{
        position:absolute;
        top: 0;
        left: 0;
        right: 0;
        bottom: 0;
        z-index: 99; 
        background-color: rgba(0, 0, 0, 0.2);

        display: flex;
        align-items: center;
        justify-content: center;
        overflow: auto;
        max-height: 100%;
    }   
    .popup-inner {
        background-color: aliceblue;
        padding: 32px;
        margin-top: 30px;
        overflow: auto;
    }
</style>